## dtkdevice 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# If do't define version number, specify the version number
set(VERSION "1.0.3" CACHE STRING "define project version")

project(DtkDevice
    VERSION ${VERSION}
    DESCRIPTION "DTK library for device."
    HOMEPAGE_URL https://github.com/linuxdeepin/dtkdevice
    LANGUAGES CXX C
)
set(LIB_NAME dtkdevice)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DDevice")
set(LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/mkspecs/modules" CACHE STRING "Install dir for qt pri files")
set(CMAKE_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/DtkDevice" CACHE STRING "Install dir for cmake config files")
set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig" CACHE STRING "Install dir for pkgconfig pc files")

set(BUILD_EXAMPLES ON CACHE BOOL "Build examples")
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie -Wl,--as-needed")
  if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
  endif ()
  string(REPLACE "-O3" "-Ofast" CMAKE_CXX_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
endif()

# Find necessary packages
find_package(PkgConfig REQUIRED)
pkg_search_module(LibNl3 REQUIRED IMPORTED_TARGET libnl-3.0)
pkg_search_module(LibNl3Route REQUIRED IMPORTED_TARGET libnl-route-3.0)
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)
find_package(Dtk REQUIRED COMPONENTS Core)

add_subdirectory(src)

if (BUILD_DOCS)
  add_subdirectory(docs)
endif ()

if(BUILD_EXAMPLES)
  message("===================================")
  message("You can build and run examples now ")
  message("===================================")
  add_subdirectory(examples)
endif()

if(BUILD_TESTING)
  message("==================================")
  message("       Now Testing is enabled     ")
  message("==================================")
  enable_testing()
  add_subdirectory(tests)
endif()

configure_package_config_file(misc/DtkDeviceConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfigVersion.cmake"
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfigVersion.cmake
    DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
)

configure_file(misc/dtkdevice.pc.in dtkdevice.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkdevice.pc DESTINATION ${PKGCONFIG_INSTALL_DIR})
set(DTK_MODULE dtkdevice)
configure_file(misc/qt_lib_dtkdevice.pri.in qt_lib_dtkdevice.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdevice.pri DESTINATION ${MKSPECS_INSTALL_DIR})

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.device")
set (DOXYGEN_QCH_FILE "dtkdevice.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkdevice")
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "DDEVICE_BEGIN_NAMESPACE=namespace Dtk { namespace Device {"
    "DDEVICE_END_NAMESPACE=}}"
    "DDEVICE_USE_NAMESPACE=using namespace Dtk::Device;"
)

doxygen_add_docs(doxygen
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
    COMMENT "Generate documentation via Doxygen"
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/html/dtkdevice.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/CMakeLists.txt ===
add_subdirectory(lsdevice)
add_subdirectory(inputdevices)

=== src/CMakeLists.txt ===
# Collect headers and sources
file(GLOB 3RDPARTY_HEADERS "${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.h")
file(GLOB 3RDPARTY_SOURCES "${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.cpp")
file(GLOB D_HEADERS "${PROJECT_SOURCE_DIR}/include/DDevice/*")
file(GLOB_RECURSE PUBLIC_HEADERS "${PROJECT_SOURCE_DIR}/include/*.h")
file(GLOB_RECURSE PRIVATE_HEADERS "${CMAKE_CURRENT_LIST_DIR}/lsdevice/*.h" "${CMAKE_CURRENT_LIST_DIR}/inputdevices/*.h")
file(GLOB_RECURSE DEVICE_SOURCES "${CMAKE_CURRENT_LIST_DIR}/lsdevice/*.cpp" "${CMAKE_CURRENT_LIST_DIR}/inputdevices/*.cpp")
list(APPEND PUBLIC_HEADERS ${D_HEADERS})

add_library(${LIB_NAME} SHARED
    ${3RDPARTY_HEADERS}
    ${3RDPARTY_SOURCES}
    ${PUBLIC_HEADERS}
    ${PRIVATE_HEADERS}
    ${DEVICE_SOURCES}
)

target_link_libraries(${LIB_NAME}
PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Dtk::Core
PRIVATE
    PkgConfig::LibNl3
    PkgConfig::LibNl3Route
)

target_compile_definitions(${LIB_NAME} PRIVATE "LIBDTKDEVICE_LIBRARY")

target_include_directories(${LIB_NAME}
PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/lsdevice>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/inputdevices>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DDevice>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/3rdparty>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/inputdevices>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/inputdevices/dbus>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/lsdevice>
INTERFACE
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_directories(${LIB_NAME} INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

set_target_properties(${LIB_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    EXPORT_NAME Device
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
)

install(TARGETS ${LIB_NAME} EXPORT DtkDeviceTargets DESTINATION ${LIBRARY_INSTALL_DIR} PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR})
install(EXPORT DtkDeviceTargets
    FILE DtkDeviceTargets.cmake
    NAMESPACE Dtk::
    DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ut-dtkdevice)

find_package(GTest REQUIRED)
file(GLOB_RECURSE HEADERS "${PROJECT_SOURCE_DIR}/include/*.h")
file(GLOB_RECURSE SOURCES
    "${PROJECT_SOURCE_DIR}/src/*.h"
    "${PROJECT_SOURCE_DIR}/src/*.cpp"
)
file(GLOB_RECURSE TEST_SOURCES "${CMAKE_CURRENT_LIST_DIR}/*.h" "${CMAKE_CURRENT_LIST_DIR}/*.cpp")

add_executable(${BIN_NAME}
    ${HEADERS}
    ${SOURCES}
    ${TEST_SOURCES}
)

target_include_directories(${BIN_NAME} PRIVATE
    "${PROJECT_SOURCE_DIR}/include/lsdevice"
    "${PROJECT_SOURCE_DIR}/include/global"
    "${PROJECT_SOURCE_DIR}/include/inputdevices"
    "${PROJECT_SOURCE_DIR}/src/3rdparty"
    "${PROJECT_SOURCE_DIR}/src/inputdevices"
    "${PROJECT_SOURCE_DIR}/src/inputdevices/dbus"
    "${PROJECT_SOURCE_DIR}/src/lsdevice"
    "${CMAKE_CURRENT_LIST_DIR}/inputdevices/fakedbus"
    "${CMAKE_CURRENT_LIST_DIR}/3rdparty/cpp-stub"
    "${CMAKE_CURRENT_LIST_DIR}/3rdparty/stub-ext"
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Dtk::Core
    PkgConfig::LibNl3
    PkgConfig::LibNl3Route
    GTest::GTest
    pthread
    gcov
    asan
)

target_compile_definitions(${BIN_NAME} PRIVATE USE_FAKE_INTERFACE)
target_compile_options(${BIN_NAME} PRIVATE -fsanitize=address)
target_link_options(${BIN_NAME} PRIVATE -fsanitize=address)
target_compile_options(${BIN_NAME} PRIVATE -fno-access-control)
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

enable_testing()
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== examples/inputdevices/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022-2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME monitor)
add_executable(${BIN_NAME} devicemonitor.cpp)
target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    ${LIB_NAME}
)

=== examples/lsdevice/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022-2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME demo-lsdevice)

file(GLOB_RECURSE SOURCES 
    "./*.h"
    "./*.cpp"
)

add_executable(${BIN_NAME}
    ${SOURCES}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    ${LIB_NAME}
    dl
)

target_compile_definitions(${BIN_NAME} PRIVATE PREFIX="${CMAKE_PREFIX_PATH}")

=== src/inputdevices/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "./*.h"
    "./*.cpp"
)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
)

target_include_directories(${BIN_NAME} PUBLIC
    "../include"
    "./dbus"
    ${DtkCore_INCLUDE_DIRS}
)


set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    ${DtkCore_LIBRARIES}
)

install(FILES ${INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
dtkdevice (1.0.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 13:42:29 +0800

dtkdevice (1.0.3) unstable; urgency=medium

  * Release 1.0.3

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 11:35:43 +0800

dtkdevice (1.0.1) unstable; urgency=medium

  * Update  release log for the dtkdevice

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 12 Jan 2023 10:39:02 +0800

dtkdevice (1.0.0) unstable; urgency=medium

  * Initial release

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 01 Jul 2022 14:29:07 +0800

=== debian/control ===
Source: dtkdevice
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 doxygen,
 qhelpgenerator-qt5 | qttools5-dev-tools,
 qtbase5-dev,
 libdtkcore-dev,
 libnl-3-dev, 
 libnl-route-3-dev,
 pkg-config
Standards-Version: 4.5.0

Package: libdtkdevice1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Tool Kit template library
 DtkDevice is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkdevice-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 libdtkdevice1( =${binary:Version})
Description: Deepin Tool Kit template devel library
 DtkDevice is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries of DtkDevice

Package: libdtkdevice-doc
Architecture: any
Depends: ${misc:Depends}
Description: Deepin Tool Kit Core (document)
 DtkDevice is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the doc files of DtkDevice

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DVERSION=$(PACK_VER)

override_dh_makeshlibs:
	dh_makeshlibs -V "libdtkcore5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkdevice 1.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,26 @@
 cmake_minimum_required(VERSION 3.10)
 
 # If do't define version number, specify the version number
-set(VERSION "1.0.3" CACHE STRING "define project version")
+set(DTK_VERSION "1.0.3" CACHE STRING "define project version")
 
 project(DtkDevice
-    VERSION ${VERSION}
+    VERSION ${DTK_VERSION}
     DESCRIPTION "DTK library for device."
     HOMEPAGE_URL https://github.com/linuxdeepin/dtkdevice
     LANGUAGES CXX C
 )
-set(LIB_NAME dtkdevice)
+
+set(ENABLE_Qt6 CACHE BOOL OFF)
+if (ENABLE_Qt6)
+    set(DTK_VERSION_MAJOR 6)
+    set(QT_VERSION_MAJOR 6)
+    set(BUILD_EXAMPLES OFF CACHE BOOL "Build examples")
+else()
+    set(QT_VERSION_MAJOR 5)
+    set(BUILD_EXAMPLES ON CACHE BOOL "Build examples")
+endif()
+
+set(LIB_NAME dtk${DTK_VERSION_MAJOR}device)
 
 include(GNUInstallDirs)
 include(CMakePackageConfigHelpers)
@@ -19,12 +30,9 @@
 endif ()
 set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DDevice")
 set(LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
-set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/mkspecs/modules" CACHE STRING "Install dir for qt pri files")
-set(CMAKE_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/DtkDevice" CACHE STRING "Install dir for cmake config files")
+set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "Install dir for qt pri files")
+set(CMAKE_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Dtk${DTK_VERSION_MAJOR}Device" CACHE STRING "Install dir for cmake config files")
 set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig" CACHE STRING "Install dir for pkgconfig pc files")
-
-set(BUILD_EXAMPLES ON CACHE BOOL "Build examples")
-set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -50,9 +58,10 @@
 find_package(PkgConfig REQUIRED)
 pkg_search_module(LibNl3 REQUIRED IMPORTED_TARGET libnl-3.0)
 pkg_search_module(LibNl3Route REQUIRED IMPORTED_TARGET libnl-route-3.0)
-find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
+
+
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)
-find_package(Dtk REQUIRED COMPONENTS Core)
+find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core)
 
 add_subdirectory(src)
 
@@ -76,22 +85,23 @@
 endif()
 
 configure_package_config_file(misc/DtkDeviceConfig.cmake.in
-    "${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfig.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeviceConfig.cmake"
     INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
 )
 write_basic_package_version_file(
-    "${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfigVersion.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeviceConfigVersion.cmake"
     VERSION ${VERSION}
     COMPATIBILITY SameMajorVersion
 )
 install(FILES
-    ${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfig.cmake
-    ${CMAKE_CURRENT_BINARY_DIR}/DtkDeviceConfigVersion.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeviceConfig.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeviceConfigVersion.cmake
     DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
 )
 
-configure_file(misc/dtkdevice.pc.in dtkdevice.pc @ONLY)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dtkdevice.pc DESTINATION ${PKGCONFIG_INSTALL_DIR})
+configure_file(misc/dtkdevice.pc.in ${LIB_NAME}.pc @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LIB_NAME}.pc DESTINATION ${PKGCONFIG_INSTALL_DIR})
+
 set(DTK_MODULE dtkdevice)
 configure_file(misc/qt_lib_dtkdevice.pri.in qt_lib_dtkdevice.pri @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdevice.pri DESTINATION ${MKSPECS_INSTALL_DIR})

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 find_package (Doxygen REQUIRED)
 
-set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
+set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")
 set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
 set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
 set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 PUBLIC
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::DBus
-    Dtk::Core
+    Dtk${DTK_VERSION_MAJOR}::Core
 PRIVATE
     PkgConfig::LibNl3
     PkgConfig::LibNl3Route
@@ -55,7 +55,7 @@
 
 install(TARGETS ${LIB_NAME} EXPORT DtkDeviceTargets DESTINATION ${LIBRARY_INSTALL_DIR} PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR})
 install(EXPORT DtkDeviceTargets
-    FILE DtkDeviceTargets.cmake
-    NAMESPACE Dtk::
+    FILE Dtk${DTK_VERSION_MAJOR}DeviceTargets.cmake
+    NAMESPACE Dtk${DTK_VERSION_MAJOR}::
     DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
 )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 target_link_libraries(${BIN_NAME} PRIVATE
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::DBus
-    Dtk::Core
+    Dtk${DTK_VERSION_MAJOR}::Core
     PkgConfig::LibNl3
     PkgConfig::LibNl3Route
     GTest::GTest

=== debian/changelog ===
dtkdevice (1.0.4) unstable; urgency=medium

  * Release 1.0.4

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 13 Feb 2023 17:25:44 +0800

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DVERSION=$(PACK_VER)
+	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DDTK_VERSION=$(PACK_VER)
 
 override_dh_makeshlibs:
 	dh_makeshlibs -V "libdtkcore5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"
